设为首页 加入收藏

TOP

一文搞清Gradle依赖(一)
2019-01-11 02:08:41 】 浏览:30
Tags:一文 搞清 Gradle 依赖

之前对 Android Gradle 构建的依赖一直傻傻分不清,这段时间正好接入集团的一个二方库,踩了很多坑,也顺带把 Gradle 依赖这块搞清楚了,主要整理了下 Gradle 依赖的类型、依赖配置、如何查看依赖、依赖冲突如何解决。

依赖类型

dependencies DSL 标签是标准 Gradle API 中的一部分,而不是 Android Gradle 插件的特性,所以它不属于 Android 标签。
依赖有三种方式,如下面的例子:

apply plugin: 'com.android.application'

android { ... }

dependencies {
    // Dependency on a local library module
    implementation project(":mylibrary")

    // Dependency on local binaries
    implementation fileTree(dir: 'libs', include: ['*.jar'])

    // Dependency on a remote binary
    implementation 'com.example.android:app-magic:12.3'
}

本地 library 模块依赖

implementation project(":mylibrary")

这种依赖方式是直接依赖本地库工程代码的(需要注意的是,mylibrary 的名字必须匹配在 settings.gradle 中 include 标签下定义的模块名字)。

本地二进制依赖

implementation fileTree(dir: 'libs', include: ['*.jar'])

这种依赖方式是依赖工程中的 module_name/libs/ 目录下的 Jar 文件(注意 Gradle 的路径是相对于 build.gradle 文件来读取的,所以上面是这样的相对路径)。

如果只想依赖单个特定本地二进制库,可以如下配置:

implementation files('libs/foo.jar', 'libs/bar.jar')

远程二进制依赖

implementation 'com.example.android:app-magic:12.3'

上面是简写的方式,这种依赖完整的写法如下:

implementation group: 'com.example.android', name: 'app-magic', version: '12.3'

group、name、version共同定位一个远程依赖库。需要注意的点是,version最好不要写成”12.3+”这种方式,除非有明确的预期,因为非预期的版本更新会带来构建问题。远程依赖需要在repositories标签下声明远程仓库,例如jcenter()、google()、maven仓库等。

依赖配置

目前 Gradle 版本支持的依赖配置有:implementation、api、compileOnly、runtimeOnly 和 annotationProcessor。已经废弃的配置有:compile、provided、apk、providedCompile。此外依赖配置还可以加一些配置项,例如 AndroidTestImplementation、debugApi 等等。

常用的是 implementation、api、compileOnly 三个依赖配置,含义如下:

  • implementation:与compile对应,会添加依赖到编译路径,并且会将依赖打包到输出(aar或apk),但是在编译时不会将依赖的实现暴露给其他module,也就是只有在运行时其他module才能访问这个依赖中的实现。使用这个配置,可以显著提升构建时间,因为它可以减少重新编译的module的数量。建议,尽量使用这个依赖配置。
  • api:与 compile 对应,功能完全一样,会添加依赖到编译路径,并且会将依赖打包到输出(aar 或a pk)。与 implementation 不同,这个依赖可以传递,其他 module 无论在编译时和运行时都可以访问这个依赖的实现,也就是会泄漏一些不应该不使用的实现。举个例子,A 依赖 B,B 依赖 C,如果都是使用 api 配置的话,A 可以直接使用 C 中的类(编译时和运行时)。而如果是使用 implementation 配置的话,在编译时,A 无法访问 C 中的类。
  • compileOnly:与 provided 对应,Gradle 把依赖加到编译路径,编译时使用,不会打包到输出(aar 或 apk)。这可以减少输出的体积,在只在编译时需要,在运行时可选的情况,很有用。
  • runtimeOnly:与 apk 对应。Gradle添加依赖只打包到 apk,运行时使用,但不会添加到编译路径。这个没有使用过。
  • annotationProcessor:与 compile 对应,用于注解处理器的依赖配置,这个没用过。

查看依赖树

可以查看单个module或者这个project的依赖,通过运行依赖的 Gradle 任务,如下:

  1. View -> Tools Windows -> Gradle(或者点击右侧的 Gradle 栏);
  2. 展开 AppName -> Tasks -> Android,然后双击运行 AndroidDependencies。运行完,就会在 Run 窗口打出依赖树了。

依赖冲突解决

随着很多依赖加入到项目中,难免会出现依赖冲突,出现依赖冲突如何解决?

定位冲突

依赖冲突可能会报类似下面的错误:

Program type already present com.example.MyClass
通过查找类的方式(command + O)定位到冲突的依赖,进行排除。

如何排除依赖

dependencies 中排除(细粒度)
compile('com.taobao.android:accs-huawei:1.1.2@aar') {
        transitive = true
        exclude group: 'com.taobao.android', module: 'accs_sdk_taobao'
}

全局配置排除

configurations {
    compile.exclude module: 'cglib'
    //全局排除原有的tnet jar包与so包分离的配置,统一使用aar包中的内容
    all*.exclude group: 'com.taobao.android', module: 'tnet-jni'
    all*.exclude group: 'com.taobao.android', module: 'tnet-so'
}

禁用依赖传递

compile('com.zhyea:ar4j:1.0') {
    transitive = false
}

configurations.all {
    transitive = false
}

还可以在单个依赖项中使用 @jar 标识符忽略传递依赖:

compile 'com.zhyea:ar4j:1.0@jar'
强制使用某个版本

如果某个依赖项是必需的,而又存在依赖冲突时,此时没必要逐个进行排除,可以使用force属性标识需要进行依赖统一
编程开发网

首页 上一页 1 2 下一页 尾页 1/2/2
】【打印繁体】【投稿】【收藏】 【推荐】【举报】【评论】 【关闭】 【返回顶部
上一篇Spring AOP是什么?你都拿它做什.. 下一篇HashMap?面试?我是谁?我在哪

评论

帐  号: 密码: (新用户注册)
验 证 码:
表  情:
内  容:

array(4) { ["type"]=> int(8) ["message"]=> string(24) "Undefined variable: jobs" ["file"]=> string(32) "/mnt/wp/cppentry/do/bencandy.php" ["line"]=> int(214) }